<?php
    include 'idp_config.php';
    include 'utils.php';
    
    error_reporting(E_ALL);
    date_default_timezone_set("UTC");
    
    if (( ! isset($_POST["SAMLRequest"])) && ( ! isset($_GET["SAMLRequest"]))) {
        header('HTTP/1.1 400 Bad Request', true, 400);
        exit;
    }
    
    function GetRequestBody() {
        $body = '';
        $fh = @fopen('php://input', 'r');
        if ($fh) {
            while ( ! feof($fh)) {
                $s = fread($fh, 1024);
                if (is_string($s)) {
                    $body .= $s;
                }
            }
        }
        fclose($fh);
        Return $body;
    }
    
    function LoadAndProcessRequest($saml, $state) {
        global $spMetaList;
        
        $login = $_SESSION['login'];
        
        if (isset($_SESSION['loggedIn']))
            $loggedIn = $_SESSION['loggedIn'];
        else
            $loggedIn = false;
        
        if ($loggedIn) {
            $ms = new TMemoryStream();
            $ms->Write($saml, strlen($saml));
            $ms->set_Position(0);
            
            $doc = new TElXMLDOMDocument();
            $doc->LoadFromStream($ms);
            
            ProcessRequest($doc, $login, $state, $spMetaList);
        } else {
            $_SESSION['requestBody'] = $saml;
            $_SESSION['requestState'] = $state;
            $_SESSION['prefferedSSOResponseBinding'] = PREFFERED_SSO_RESP_BINDING;
            $_SESSION['idpIssuer'] = IDP_ISSUER;
            $_SESSION['signCertPath'] = SIGN_CERT;
            $_SESSION['signResponses'] = SIGN_RESPONSES;
            
            $finfo = new finfo(FILEINFO_MIME);
            header('Content-Type: ' . $finfo->file(LOGIN_FORM));
            header('Content-Length: ' . filesize(LOGIN_FORM));

            ob_clean();
            flush();
            readfile(LOGIN_FORM);
        }
    }
    
    if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) {
        print "SecureBlackbox extension NOT available";
        die;
    }
        
    try {
        if (!SBUtils\GetLicense()) {
          #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it in "sbb.license_key" php.ini directive or here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
          SBUtils\SetLicenseKey("<enter license key here>");
        }
    } catch (SBException $e) {
        print "<p style='color:red'>Setting SBB License Key failed with message: <br/>" . $e->getErrorMessage() . "</p>";
        die;
    }
    
    session_start();
    
    $method = $_SERVER['REQUEST_METHOD'];
    switch ($method) {
      case 'POST':
        $binding = new TElSAMLPOSTBinding();
        $binding->set_Mode(TSBSAMLPOSTBindingMode::spmServer);
        
        $body = GetRequestBody();
        $saml = $binding->LoadRequest($body);
        $state = $binding->get_RelayState();
        
        LoadAndProcessRequest($saml, $state);
        break;
      case 'GET':
        $binding = new TElSAMLRedirectBinding();
        $binding->set_VerifySignatures(false);
        
        $body = '?' . $_SERVER['QUERY_STRING'];
        $saml = $binding->LoadRequest($body);
        $state = $binding->get_RelayState();
        
        LoadAndProcessRequest($saml, $state);
        break;
      default:
        header('HTTP/1.1 400 Bad Request', true, 400);
        exit;
    }
?>
